#include "msgClient.hh"
#include <yarp/os/Network.h>
#include <yarp/os/BufferedPort.h>
#include <yarp/os/Bottle.h>

using namespace std;
using namespace yarp::os;

static string NAME_OF_MSGC		= "";
static string NAME_OF_YARPIN	= "";
static string NAME_OF_YARPOUT	= "";
static string MSGC_SERV 		= "";

static int MSGC_PORT = 5500;
static int VERBOSE_MODE = 0;

int main(int argc, char *argv[]){

	if(argc == 6) {
		NAME_OF_MSGC	= argv[1];
		MSGC_SERV		= argv[2];
		NAME_OF_YARPIN	= argv[3];
		NAME_OF_YARPOUT	= argv[4];
		VERBOSE_MODE	= atoi(argv[5]);
	}
	else {
		cerr << "Args error. Usage: NAME_OF_MSGC MSGC_SERV NAME_OF_YARPIN NAME_OF_YARPOUT VERBOSE_MODE" << endl;
		exit(0);
	}

	// ----- Connection to msgconnector Server
	msgClient* mp = new msgClient();
	mp->connect(NAME_OF_YARPIN, MSGC_SERV, MSGC_PORT);
	if(!mp->isConnected()) {
		cerr << "Unable to connect to msgconnector Server... exit." << endl;
		exit(0);
	}

	// ----- Connection To YARP Server
	Network yarp;
	yarp::os::BufferedPort<yarp::os::Bottle> yarpPortIn;
	yarp::os::BufferedPort<yarp::os::Bottle> yarpPortOut;
	ostringstream yportname;
	bool connected = false;
	connected = yarpPortIn.open(NAME_OF_YARPIN.c_str()) && yarpPortOut.open(NAME_OF_YARPOUT.c_str());
	if(!connected) {
		cerr << "Unable to connect to YARP Server... exit." << endl;
		exit(0);
	}
	
	// ----- Main loop - Message Transfer
	while(mp->isConnected()) {
		usleep(1000); // delay: 1ms
		if(mp->isMessageWaiting()) { // message from msgc ?
			pair<string, string> msg1 = mp->getMessage();
			if(VERBOSE_MODE == 1) cout << "[MSGC]Received from " << msg1.first << ": " << msg1.second << endl;
			Bottle& botData = yarpPortOut.prepare(); 
   			botData.addString(msg1.second.c_str()); 
			yarpPortOut.write();
		}
		Bottle *yarpData = yarpPortIn.read(false);
		if(yarpData != NULL) { // message from yarp ?
			Value yval = yarpData->pop();
			mp->sendMessage(NAME_OF_MSGC, yval.asString().c_str());
		}
	}

}
